public class SM_RunSheetControllerX
{
    // ******************************************************************************** //
    // ** THIS CONTROLLER EXTENSION IS USED FOR THE MAJORITY OF SAND RUN SHEET LOGIC ** //
    // ******************************************************************************** //


    
    //////////////////////////
    // * SAND OBJECT DATA * //
    //////////////////////////

    private List<SM_Run_Sheet_Detail__c> lViewSandDetails;
    private List<SM_Sand_Request_Vendor_Ticket__c> lSandDetailVendors;
    private List<SM_Sand_Request_Vendor_Ticket__c> lSandDetailVendorsToRemove;
    private List<SandDetailVendorsWrapper> lSandDetailVendorsWrapper {get; set;}  //mz 17.6.2016
    private Map<Id, SM_Sand_Request_Vendor_Ticket__c> lSandDetailVendorsInDb; //Need this to rollback the invalid upserts without causing 'Data Not Available' error.
    public  Map<Id, Integer> sandDetailVendorCountMap {get; set;}
    public  Map<Id, String> sandDetailStatusMap {get; set;}

    private List<SM_Run_Sheet_Detail__c> lAddSandDetails;
    private SM_CustomWellOrder__c oCustomWellOrderData;

    private SM_Run_Sheet__c oNewSheet;
    private SM_Run_Sheet__c oViewSheet;

    public Integer rowToRemove {get; set;}
    public Id sandRequestId {get; set;}
    
    ////////////////////////////////
    // * LOCATION-SPECIFIC DATA * //
    ////////////////////////////////

    private Map<Id, Location__c> mapLocations;
    private List<SelectOption> lRouteList;
    private List<SelectOption> lLocationList;

    private String sRouteNum;
    private String sRouteId;
    private String sRouteName;

    public Location__c oSelectedLocation {get; set;}
    public Well_Event__c oSelectedLocationPvr {get; private set;}
    public List<SelectOption> lSelectedWells {get; set;}
    public List<SelectOption> lAllWells {get; set;}

    public String sSelectedLocationId {get;set;}
    public String sSavedSelectedWells {get;set;}

    /////////////////////////////////////
    // * H2S Readings * //
    /////////////////////////////////////


    public List<Well_Location_H2S_Reading__c> lH2S_Readings {get; set;}
    //public Well_Location_H2S_Reading__c NewH2SReading {get; set;}


    /////////////////////////////////////
    // * MISCELLANEOUS CONFIGURATION * //
    /////////////////////////////////////

    private Date dToday;

    private String sObjectId;
    private String sWellId;
    private String sUrlRouteNum;
    private String sTankId;
    private String sCurrentUserId;
    private String sCurrentUserName;

    private Boolean bIsHogAdmin;
    private Boolean bIsSandLead;
    private Boolean bErrorsPresent;

    public List<SelectOption> lDestinationLocations {get; private set;}    

    public List<SelectOption> pmVendorPLvalues {get; private set;} //mz 7.6.2016
    public List<SelectOption> pmUnitTypePLvalues {get; private set;} //mz 7.6.2016

    public Id pmDestOrFacId {get; set;} //mz 10.6.2016

    public Map<Id, String> disposalIdNameMap;   //mz 10.6.2016
    public Map<Id, String> pmVendorIdNameMap;   //mz 10.6.2016
    //public Map<Id, String> pmUnitTypeIdNameMap;    //mz 10.6.2016


    //////////////////////////////
    // * RM PICKLIST ON SAND  * //
    //////////////////////////////
    //public List<SelectOption> pickvalsRM { get;private set; }
    public Set<String> rmSet { get; private set; }


    //mz:22.8.2016
    ///////////////////////////////////////
    // * PMIMARY DISPOSAL MASS-UPDATE  * //
    ///////////////////////////////////////
    public ApexPages.StandardSetController setController;  

    public String dName = '';
    public String selectedDisposal {get; set;} 

    public List<SM_Run_Sheet_Detail__c> massUpdList; 
    public List<SM_Run_Sheet_Detail__c> viewSRList;
    private List<SM_Run_Sheet_Detail__c> tempSRList;
    private List<Id> tempSRIdList;

    public Boolean massUpdateFailed {get; set;} 
    public Boolean succ{get; set;}
    
    public Integer errorNum;




    /////////////////////////////
    // * SAND CHILD PICKLIST * //
    /////////////////////////////

    public List<SelectOption> StingStatusList
    {
        get
        {
            if(StingStatusList == null)
            {
                StingStatusList = SM_Utilities.GetSandDetailStatusPickList();
            }

            return StingStatusList;
        }

        private set;
    }

    //////////////////////////
    // * MAIN CONSTRUCTOR * //
    //////////////////////////

    public SM_RunSheetControllerX(ApexPages.StandardController stdController)
    {
        SetConfigurationData();
        SetDefaultLocationData();

        InitializeSandData();
        LoadWellParameter();

        LoadDestinationLocations();     
        LoadVendorPicklistValues();  //mz 7.6.2016
        LoadUnitTypePicklistValues(); //mz 7.6.2016
    }

    




    //mz: 22.8.2016 - Mass Update Primary Disposal on SR
    public SM_RunSheetControllerX(ApexPages.StandardSetController controller){
       
        setController = controller;
        LoadDestinationLocations();

        tempSRList = (List<SM_Run_Sheet_Detail__c>) setController.getSelected();
        tempSRIdList = new List<Id>();

        for (SM_Run_Sheet_Detail__c sr : tempSRList) {

            tempSRIdList.Add(sr.Id);

        }


        viewSRList = new List<SM_Run_Sheet_Detail__c>([SELECT Name,Disposal_Destination__c, Primary_Disposal_Facility__c,
                                                            Primary_Disposal_Facility_Ext__c
                                                       FROM SM_Run_Sheet_Detail__c
                                                       WHERE Id 
                                                       IN : tempSRIdList]); 

}



    public integer getSelectedSize() {

        return setController.getSelected().size();
    }



    public String getDisposalName() {

        massUpdateFailed = false;

        if (selectedDisposal != 'none'){

             dName = disposalIdNameMap.get(selectedDisposal);  
        }

        else if (selectedDisposal == 'none') {

            dName = null;
        }

        return dName;
    }

        

        public PageReference MassUpdatePrimaryDisposal(){
        
        List<SM_Run_Sheet_Detail__c> massUpdList = new List<SM_Run_Sheet_Detail__c>();
        massUpdList = viewSRList.deepClone(true,true);//(List<SM_Run_Sheet_Detail__c>) setController.getRecords();

        Schema.DescribeSObjectResult result = SM_Run_Sheet_Detail__c.SObjectType.getDescribe(); 
        PageReference pageRef = new PageReference('/' + result.getKeyPrefix()); 
        pageRef.setRedirect(true); 

        Id selectedDisposalId;
        
        succ = false;
        errorNum = 0;

        

        try{

            for(SM_Run_Sheet_Detail__c srd : massUpdList){


                if (selectedDisposal != 'none'){

                    selectedDisposalId = selectedDisposal;

                    if (selectedDisposal != 'none' && selectedDisposalId.getSObjectType().getDescribe().getName() == 'Facility__c'){

                        srd.Primary_Disposal_Facility__c = selectedDisposalId;
                        srd.Primary_Disposal_Facility_Ext__c = null;
                    }

                    else if (selectedDisposal != 'none' && selectedDisposalId.getSObjectType().getDescribe().getName() == 'HOG_Picklist_Manager__c'){
                   
                        srd.Primary_Disposal_Facility__c = null;
                        srd.Primary_Disposal_Facility_Ext__c = selectedDisposalId;
                    }

                }

                else if (selectedDisposal == 'none'){

                    srd.Primary_Disposal_Facility__c = null;
                    srd.Primary_Disposal_Facility_Ext__c = null;
                    srd.Disposal_Destination__c = null;
                }

            }

            system.debug(massUpdList);

            massUpdateFailed = false;
            //setController.save();
            //update massUpdList;
            Database.SaveResult[] srList = Database.update(massUpdList, true);

            
            for (Database.SaveResult sr : srList){

                if(!sr.isSuccess()) {

                    errorNum++;
                }

            }   


            if (errorNum > 0) {
              
                massUpdateFailed = true;
                succ = false;
            }

            else {

                succ = true;
            }

        }

        
        catch  (Exception ex){

            //ApexPages.addMessages(ex);
            massUpdateFailed = true;
            succ = false;
            
        }

        if (succ) {

            return pageRef;
        }

        else {

            return null; 
        }
    }


    ///////////////////////////////////////
    // * SET GLOBAL CONFIGURATION DATA * //
    ///////////////////////////////////////

    private void SetConfigurationData()
    {
        this.dToday = Date.today();
        this.sObjectId = ApexPages.CurrentPage().getParameters().get('id');
        this.sWellId = ApexPages.CurrentPage().getParameters().get('wellid');
        this.sTankId = ApexPages.CurrentPage().getParameters().get('tank');
        this.sUrlRouteNum = ApexPages.CurrentPage().getParameters().get('route');

        this.sCurrentUserId = UserInfo.getUserId();
        this.sCurrentUserName = UserInfo.getName();

        this.bIsHogAdmin = SM_Utilities.VerifyProfile(SM_Utilities.PROFILE_HOG_ADMIN) || SM_Utilities.VerifyProfile(SM_Utilities.PROFIlE_SYSTEM_ADMIN);
        this.bIsSandLead = SM_Utilities.VerifyPermissions(this.sCurrentUserId, SM_Utilities.PERMISSION_SET_SAND_LEAD);
        this.bErrorsPresent = false;
    }

    ///////////////////////////////////
    // * SET DEFAULT LOCATION DATA * //
    ///////////////////////////////////

    private void SetDefaultLocationData()
    {
        this.mapLocations = new Map<Id, Location__c>();
        this.lRouteList = new list<SelectOption>();

        List<Route__c> lAvailableRoutes = [SELECT Id, Name FROM Route__c WHERE Fluid_Management__c = true AND Id IN (SELECT Route__c FROM Location__c) ORDER BY Name];

        for(Route__c oOneRoute : lAvailableRoutes)
        {
            this.lRouteList.add(new SelectOption(oOneRoute.Id, oOneRoute.Name));
        }
    }

    /////////////////////////////////
    // * INITIALIZE SAND OBJECTS * //
    /////////////////////////////////

    private void InitializeSandData()
    {
        this.oNewSheet = new SM_Run_Sheet__c();
        this.oNewSheet.Date__c = dToday;

        this.oViewSheet = (this.sObjectId != null) ? LoadSandViewParentData() : new SM_Run_Sheet__c();
        this.lViewSandDetails = (this.sObjectId != null) ? LoadSandViewChildData() : new List<SM_Run_Sheet_Detail__c>();
        
        this.lSandDetailVendorsToRemove = new List<SM_Sand_Request_Vendor_Ticket__c>();

        //load H2S Readings
        if(this.sObjectId != null)
        {
            sSelectedLocationId = this.oViewSheet.Well_Location__c;
            RetrieveH2SReadings();
        }

        // Load PVR Data
        if(this.oSelectedLocation != null)
        {
            List<Well_Event__c> lPvrData = [SELECT Id, PVR_AVGVOL_30D_OIL__c, PVR_AVGVOL_30D_SAND__c, PVR_AVGVOL_30D_WATER__c FROM Well_Event__c WHERE  Well_ID__c = :this.oSelectedLocation.Id AND Status__c = 'PROD' ORDER BY LastModifiedDate DESC LIMIT 1];

            // NO PRODUCING EVENT --> CHECK FOR SHUT
            if(lPvrData.size() == 0)
            {
                lPvrData = [SELECT Id, PVR_AVGVOL_30D_OIL__c, PVR_AVGVOL_30D_SAND__c, PVR_AVGVOL_30D_WATER__c FROM Well_Event__c WHERE  Well_ID__c = :this.oSelectedLocation.Id AND Status__c = 'SHUT' ORDER BY LastModifiedDate DESC LIMIT 1];

                // NO SHUT EVENT --> CHECK FOR SUSP
                if(lPvrData.size() == 0)
                {
                    lPvrData = [SELECT Id, PVR_AVGVOL_30D_OIL__c, PVR_AVGVOL_30D_SAND__c, PVR_AVGVOL_30D_WATER__c FROM Well_Event__c WHERE  Well_ID__c = :this.oSelectedLocation.Id AND Status__c = 'SUSP' ORDER BY LastModifiedDate DESC LIMIT 1];
                }
            }

            this.oSelectedLocationPvr = (lPvrData.size() == 1) ? lPvrData[0] : null;

            this.oNewSheet.OIL_Prod_m3__c = (this.oSelectedLocationPvr != null) ? this.oSelectedLocationPvr.PVR_AVGVOL_30D_OIL__c : 0;
            this.oNewSheet.Water_Prod_m3__c = (this.oSelectedLocationPvr != null) ? this.oSelectedLocationPvr.PVR_AVGVOL_30D_WATER__c : 0;
        }
    }

    ////////////////////////////////////////////////////////////////////
    // * LOAD WELL PARAMETER (IF FOUND) OTHERWISE USE DEFAULT ROUTE * //
    ////////////////////////////////////////////////////////////////////

    private void LoadWellParameter()
    {
        InitializeLocationData();
        SelectDefaultRoute();

        if(this.sWellId != null)
        {
            List<Location__c> lCheckLocations = [SELECT Id, Name, Route__c, Route__r.Name FROM Location__c WHERE Id = :this.sWellId LIMIT :SM_Utilities.SINGLE_RESULT];
            Location__c oCheckLocation;

            if(lCheckLocations.size() == SM_Utilities.SINGLE_RESULT)
            {
                oCheckLocation = lCheckLocations[0];
                this.sRouteID = oCheckLocation.Route__c;
                this.sRouteName = oCheckLocation.Route__r.Name;

                RefreshLocationList();
                sSelectedLocationId = sWellId;
                RefreshSelectedWell();
            }
        }
        else
        {
            RefreshLocationList();
        }
    }

    //////////////////////////////////
    // * INITIALIZE LOCATION DATA * //
    //////////////////////////////////

    private void InitializeLocationData()
    {
        this.lAllWells = new List<SelectOption>();
        this.lSelectedWells = new List<SelectOption>();
        this.lLocationList = new List<SelectOption>();
        this.oSelectedLocation = null;
        this.oNewSheet.Well_Location__c = null;
        this.sSelectedLocationId = null;
    }

    ///////////////////////////////////////////////////////////////////////////////////
    // * SELECT DEFAULT ROUTE -> BASED ON PREVIOUS ENTRY OR BASED ON URL PARAMETER * //
    ///////////////////////////////////////////////////////////////////////////////////

    private void SelectDefaultRoute()
    {
        List<Route__c> lRoutesFound;
        List<SM_Run_Sheet__c> lLastRunSheets;

        lRoutesFound = [SELECT Id FROM Route__c WHERE Name = :this.sUrlRouteNum OR Route_Number__c = :this.sUrlRouteNum LIMIT :SM_Utilities.SINGLE_RESULT];

        if(lRoutesFound.size() == SM_Utilities.SINGLE_RESULT)
        {
            this.sRouteId = lRoutesFound[0].Id;
            RefreshLocationList();
        }
        else
        {
            lLastRunSheets = [SELECT Id, Name, Well_Location__r.Route__c FROM SM_Run_Sheet__c WHERE CreatedById = :this.sCurrentUserId ORDER BY CreatedDate DESC LIMIT :SM_Utilities.SINGLE_RESULT];

            if(lLastRunSheets.size() == SM_Utilities.SINGLE_RESULT)
            {
                this.sRouteId = lLastRunSheets[0].Well_Location__r.Route__c;
                RefreshLocationList();
            }
        }
    }

    ///////////////////////////////////
    // * REFRESH THE LOCATION LIST * //
    ///////////////////////////////////

    public PageReference RefreshLocationList()
    {
        Map<String, List<SelectOption>> mapLocationData = new Map<String, List<SelectOption>>();
        List<String> lSelectedWell = new List<String>();
        Set<String> setSelectedWell = new Set<String>();

        InitializeLocationData();
        RetrieveWellOrderData();
        SetRouteData(this.sRouteId);

        if(this.sSavedSelectedWells != null && this.sSavedSelectedWells.trim() != '')
        {
            lSelectedWell = sSavedSelectedWells.split(',');
            setSelectedWell = new Set<String>(lSelectedWell);
        }

        if(this.sRouteId != null)
        {
            mapLocationData = SM_Utilities.BuildLocationMaps(lSelectedWell, setSelectedWell, this.sRouteId);
            this.lLocationList = mapLocationData.get(SM_Utilities.LOCATION_INDEX_LOCATION_LIST);

            this.lAllWells = mapLocationData.get(SM_Utilities.LOCATION_INDEX_ALL_WELLS);
            this.lSelectedWells = mapLocationData.get(SM_Utilities.LOCATION_INDEX_SELECTED_WELLS);

            this.mapLocations = new Map<Id, Location__c>(SM_Utilities.GetLocationList(this.sRouteId));
        }

        return null;
    }

    /////////////////////////
    // * SET ROUTE DATA  * //
    /////////////////////////

    private void SetRouteData(String sOneRouteId)
    {
        List<Route__c> lFoundRoute = [SELECT Id, Name, Route_Number__c FROM Route__c WHERE Id = :sOneRouteId LIMIT :SM_Utilities.SINGLE_RESULT];
        this.sRouteName = (lFoundRoute.size() == SM_Utilities.SINGLE_RESULT) ? lFoundRoute[0].Name : null;
        this.sRouteNum = (lFoundRoute.size() == SM_Utilities.SINGLE_RESULT) ? lFoundRoute[0].Route_Number__c : null;
    }

    /////////////////////////////////////////
    // * LOAD DESTINATION FACILITY DATA  * //
    /////////////////////////////////////////

    public void LoadDestinationLocations()
    {


        lDestinationLocations = new List<SelectOption>(); 
        disposalIdNameMap = new Map<Id, String>();



        List<Facility__c> lFacilities = [SELECT Id, Name FROM Facility__c WHERE Sand_Destination_Ind__c = true order by Name];

        List<HOG_Picklist_Manager__c> pmList = [SELECT Id, Picklist_Name__c, Picklist_Value__c 
                                                FROM HOG_Picklist_Manager__c 
                                                WHERE Picklist_Name__c = 'Disposal' 
                                                ORDER BY Picklist_Name__c];

        //populating disposal location picklist with bot internal and extrnal facilities                                        
        for(Facility__c facRec :lFacilities)
        {
            lDestinationLocations.add(new SelectOption(facRec.id, facRec.Name));
            disposalIdNameMap.put(facRec.id, facRec.Name );
        }

        for(HOG_Picklist_Manager__c pmRec : pmList)
        {
            lDestinationLocations.add(new SelectOption(pmRec.id, pmRec.Picklist_Value__c));
            disposalIdNameMap.put(pmRec.id, pmRec.Picklist_Value__c);
        }
  
        //pre-populating of picklis value for Primary Disposal with actual value
        if (sTankId != null){

            List<SM_Run_Sheet_Detail__c> sandDetailList= [SELECT Id, Name, Disposal_Destination__c, Primary_Disposal_Facility__c, Primary_Disposal_Facility_Ext__c 
                                                          FROM SM_Run_Sheet_Detail__c 
                                                          WHERE Id = :sTankId LIMIT 1];

            //pre-populating pickval if internal facility with selected value
            // MJ test
            System.debug('ZZZ disposalIdNameMap:' + disposalIdNameMap);
            System.debug('ZZZ SAND DETAIL LIST:' + sandDetailList);
            System.debug('ZZZ TankID:' + sTankId);
            if (sandDetailList.Size() > 0 && sandDetailList[0].Primary_Disposal_Facility__c != null && disposalIdNameMap.containsKey(sandDetailList[0].Primary_Disposal_Facility__c)){

                pmDestOrFacId = sandDetailList[0].Primary_Disposal_Facility__c;
            }

            //pre-populating pickval if external facility with selected value
            else if (sandDetailList.Size() > 0 && sandDetailList[0].Primary_Disposal_Facility_Ext__c != null && disposalIdNameMap.containsKey(sandDetailList[0].Primary_Disposal_Facility_Ext__c)){

                pmDestOrFacId = sandDetailList[0].Primary_Disposal_Facility_Ext__c;
            }

            //pre-populating -- NONE --
            else pmDestOrFacId = null;
            
        }

       
        


    }


    
    
    //////////////////////////////////////////////////////////////
    // * LOAD PICKLIST MANAGER PL VALUES - Vendor, Unit Type  * // 
    /////////////////////////////////////////// ///////////////////
    //mz 8.6.2016
    
    private void LoadVendorPicklistValues(){

        pmVendorIdNameMap = new Map<Id, String>();       
        pmVendorPLvalues = new List<SelectOption>();

        List<HOG_Picklist_Manager__c> pmList = [SELECT Id, Picklist_Name__c, Picklist_Value__c 
                                                FROM HOG_Picklist_Manager__c 
                                                WHERE Picklist_Name__c = 'Vendor' 
                                                ORDER BY Picklist_Name__c];
        
        for(HOG_Picklist_Manager__c pmRec : pmList)
        {
            pmVendorPLvalues.add(new SelectOption(pmRec.Id, pmRec.Picklist_Value__c));
            pmVendorIdNameMap.put(pmRec.Id, pmRec.Picklist_Value__c);
        }
    }


    private void LoadUnitTypePicklistValues(){
               
        //pmUnitTypeIdNameMap = new Map<Id, String>();  
        pmUnitTypePLvalues = new List<SelectOption>();

        List<HOG_Picklist_Manager__c> pmList = [SELECT Id, Picklist_Name__c, Picklist_Value__c 
                                                FROM HOG_Picklist_Manager__c 
                                                WHERE Picklist_Name__c = 'Unit Type' 
                                                ORDER BY Picklist_Name__c];
        
        for(HOG_Picklist_Manager__c pmRec : pmList)
        {
            pmUnitTypePLvalues.add(new SelectOption(pmRec.Id, pmRec.Picklist_Value__c));
            //pmUnitTypeIdNameMap.put(pmRec.Id, pmRec.Picklist_Value__c);
        }
    }
    

    //////////////////////////////////////////////
    // * LOAD VIEW MODE DATA -> PARENT OBJECT * //
    //////////////////////////////////////////////

    private SM_Run_Sheet__c LoadSandViewParentData()
    {
        List<SM_Run_Sheet__c> lRunSheets = [SELECT Id, Name, Date__c, Operator_Phone_Number__c, 
                                            Well_Location__c, Well_Location__r.Name, Is_Current_Date__c, 
                                            Well_Location__r.Route__c, Is_Editable__c, 
                                            Well_Location__r.Route__r.Name, Well_Location__r.Cost_Center__c, 
                                            Well_Location__r.Senior__c, Sand_Lead__c, Tank_Count__c, 
                                            Hazardous_H2S__c, Well_Location__r.Current_Well_Status__c, 
                                            Well_Location__r.Statusicon__c, 
                                            Well_Location__r.Surface_Location__c, Employee2z__c, RM__c, 
                                            Water_Transfer__c, OIL_Prod_m3__c, Water_Prod_m3__c, 
                                            Well_Location__r.Route__r.Field_Senior__r.Id, 
                                            Well_Location__r.Route__r.Field_Senior__r.FirstName, 
                                            Well_Location__r.Route__r.Field_Senior__r.LastName, 
                                            Well_Location__r.PVR_AVGVOL_30D_SAND__c, 
                                            CreatedById 
                                            FROM SM_Run_Sheet__c 
                                            WHERE Id = :sObjectId LIMIT :SM_Utilities.SINGLE_RESULT];

        return (lRunSheets.size() == SM_Utilities.SINGLE_RESULT) ? lRunSheets[0] : new SM_Run_Sheet__c();
    }

    ////////////////////////////////////////////////
    // * LOAD VIEW MODE DATA -> CHILD OBJECT(S) * //
    ////////////////////////////////////////////////

    private List<SM_Run_Sheet_Detail__c> LoadSandViewChildData()
    {
        List<SM_Run_Sheet_Detail__c> lSandData = new List<SM_Run_Sheet_Detail__c>();
        Set<Id> sandDetailIdSet = new Set<Id>();
        List<AggregateResult> VendorCounts;

        this.lSandDetailVendorsWrapper = new List<SandDetailVendorsWrapper>();
        SandDetailVendorsWrapper oneWrapper;
        Id dId = null;

        
        // PARENT RECORD FOUND -> LOAD CHILD OBJECTS
        if(this.oViewSheet.Id != null)
        {
            lSandData = [SELECT Sand_Run_Sheet__r.Text_Date__c, 
                        Sand_Run_Sheet__r.Operator_Phone_Number__c, 
                        Sand_Run_Sheet__r.Well_Location__r.Route__r.Name, 
                        Sand_Run_Sheet__r.Well_Location__r.Name, Flowline_push__c, 
                        Sand_Run_Sheet__r.Well_Location__r.Cost_Center__c, 
                        Sand_Run_Sheet__r.Saved_H2S__c, Sand_Run_Sheet__r.Hazardous_H2S__c, 
                        Sand_Run_Sheet__r.Well_Location__r.Senior__c, Id, Name, 
                        Tank__c, Sand_Level__c, Water_Level__c, Chem_and_Rate__c, 
                        Priority__c, Location_for_Water_Well__c, Location_for_Water_Well__r.Name, 
                        Text_Vendor_Date_given_out__c, Location_for_Water_Tank__c, Flood_Up__c, 
                        Sand_Id__c, Blow_off_location__c, Sting_Type__c, 
                        Vendor_Date_given_out__c, Work_Order__c,
                        Tank_Level__c, Sand_Run_Sheet__r.Employee2z__c, Sand_Run_Sheet__r.RM__c, 
                        Status__c, Comments__c,
                        Primary_Disposal_Facility__c,
                        Disposal_Destination__c,    //mz 10.6.2016
                        Primary_Disposal_Facility_Ext__c,   //mz 16.6.2016
                        Primary_Disposal_Facility_Ext__r.Picklist_Value__c, //mz 16.6.2016
                        Primary_Vendor_PM__c,    //mz 16.6.2016
                        Primary_Vendor_PM__r.Picklist_Value__c,  //mz 16.6.2016
                        Primary_Vendor__c,
                        Request_Completed__c                        
                        FROM SM_Run_Sheet_Detail__c 
                        WHERE Sand_Run_Sheet__c = :oViewSheet.Id 
                        AND Tank_Enabled__c = true 
                        ORDER BY Sand_Run_Sheet__r.Well_Location__r.Route__r.Name, Tank__c];
                        
            sandDetailIdSet = (new Map<Id, SM_Run_Sheet_Detail__c>(lSandData)).keySet();
        }

        if (lSandData.size() > 0)
        {
            sandDetailVendorCountMap = new Map<Id, Integer>();
            sandDetailStatusMap = new Map<Id, String>();
            
            for (SM_Run_Sheet_Detail__c sand : lSandData)
            {
                sandDetailVendorCountMap.put(sand.Id, 0);
                sandDetailStatusMap.put(sand.Id, sand.Status__c);
            }
            
            System.debug('first ' + sandDetailVendorCountMap);          
            lSandDetailVendors = [SELECT Sand_Request__r.Id, Vendor__c, Truck_Type__c, Unit_Number__c, 
                        Ticket_Date__c, Ticket_Number__c, 
                        Ticket_Hours__c, Ticket_Volume_m3__c,
                        Disposal_Facility__c,
                        Invoice_Number__c,
                        Disposal_Location_Invoice_Number__c,
                        Disposal_Location_Invoiced_Volume__c,
                        Disposal_Location_Name__c,  //mz 10.6.2016
                        Disposal_Facility_Ext__c,   //mz 16.6.2016
                        Disposal_Facility_Ext__r.Picklist_Value__c, //mz 16.6.2016
                        Truck_Type_PM__c,    //mz 16.6.2016
                        Truck_Type_PM__r.Picklist_Value__c,  //mz 16.6.2016
                        Vendor_PM__c,   //mz 16.6.2016
                        Vendor_PM__r.Picklist_Value__c, //mz 16.6.2016
                        Disposal_Fluid_Volume__c,
                        Disposal_Solids_Volume__c 
                        FROM SM_Sand_Request_Vendor_Ticket__c
                        WHERE Sand_Request__c IN :sandDetailIdSet
                        ORDER BY Vendor__c];
            lSandDetailVendorsInDb = new Map<Id, SM_Sand_Request_Vendor_Ticket__c>([SELECT Id
                        FROM SM_Sand_Request_Vendor_Ticket__c
                        WHERE Sand_Request__c IN :sandDetailIdSet]);
            
            VendorCounts = [SELECT Count(Id) vendorCount, Sand_Request__c
                            FROM SM_Sand_Request_Vendor_Ticket__c
                            WHERE Sand_Request__c IN :sandDetailIdSet
                            GROUP BY Sand_Request__c];
            

            for (SM_Sand_Request_Vendor_Ticket__c vt : lSandDetailVendors){
            
                if (vt.Disposal_Facility_Ext__c != null){

                    dId = vt.Disposal_Facility_Ext__c;
                }

                else if (vt.Disposal_Facility__c != null){

                    dId = vt.Disposal_Facility__c;
                }

                else {

                    dId = null;
                }

                oneWrapper = new SandDetailVendorsWrapper(vt, dId);
                lSandDetailVendorsWrapper.add(oneWrapper);
            }

            System.Debug('debug_lSandDetailVendorsWrapper ' + lSandDetailVendorsWrapper);


            for (AggregateResult vendorCount : VendorCounts)
            {
                sandDetailVendorCountMap.put((Id)vendorCount.get('Sand_Request__c'), (Integer)vendorCount.get('vendorCount'));
            }   
            system.debug('second ' + sandDetailVendorCountMap);         
        }
        
        return (lSandData.size() > SM_Utilities.NO_RESULT) ? lSandData : new List<SM_Run_Sheet_Detail__c>(); 
    }

    /////////////////////////////////////////////////////////////////////
    // * LOAD H2S READINGS DATA                                      * //
    /////////////////////////////////////////////////////////////////////

    private void RetrieveH2SReadings()
    {
        lH2S_Readings = [select id, name, Value__c, UOM__c, H2S_Reading__c, CreatedDate from Well_Location_H2S_Reading__c 
                    where Well_Location__c = :sSelectedLocationID 
                    order by CreatedDate desc 
                    limit 12];
        //NewH2SReading = new Well_Location_H2S_Reading__c(Well_Location__c = sSelectedLocationID);

    }

    /////////////////////////////////////////////////////////////////////
    // * CHECK IF PREVIOUS SAND RUNSHEET EXISTS -> LOAD DATA FROM IT * //
    /////////////////////////////////////////////////////////////////////

    private void CheckPreviousSandRunSheet()
    {
        List<SM_Run_Sheet__c> lRequestFound = [SELECT Id, Name, Cost_Center__c, Date__c, Door_Pulls__c, Employee2z__c, Field_Senior__c, Hazardous_H2S__c, Saved_H2S__c, Is_Current_Date__c, Is_Editable__c, New_Count__c, OIL_Prod_m3__c, Operator_Phone_Number__c, RM__c, Route__c, Sand_Lead__c, Tank_Count__c, Water_Prod_m3__c, Water_Transfer__c, Well_Location__c, Well_Status__c FROM SM_Run_Sheet__c WHERE Well_Location__c = :this.oSelectedLocation.id AND Date__c = TODAY LIMIT :SM_Utilities.SINGLE_RESULT];
        List<SM_Run_Sheet__c> lPrevious = [SELECT Id, Name, Date__c, Employee2z__c, OIL_Prod_m3__c, Cost_Center__c, Field_Senior__c, Hazardous_H2S__c, Saved_H2S__c, Operator_Phone_Number__c, RM__c, Route__c, Sand_Lead__c, Water_Prod_m3__c, Water_Transfer__c, Well_Location__c, Well_Status__c FROM SM_Run_Sheet__c WHERE Well_Location__c = :this.oSelectedLocation.Id ORDER BY CreatedDate DESC LIMIT :SM_Utilities.SINGLE_RESULT];

        

        if(lRequestFound.size() == SM_Utilities.SINGLE_RESULT)
        {
            this.oNewSheet = lRequestFound[0];                      
        }
        else
        {
            InitializeSandData();
        }

        if(lPrevious.size() > SM_Utilities.NO_RESULT)
        {
            this.oNewSheet.Water_Transfer__c = lPrevious[0].Water_Transfer__c;          

            if (lPrevious[0].RM__c != null){

                    //if previous rm from sand request is presented in rm picklist than pre-populate rm with this value
                    if (this.rmSet.contains(lPrevious[0].RM__c.toLowerCase())){

                        this.oNewSheet.RM__c = lPrevious[0].RM__c;
                    }
            }
        }
        else
        {
            this.oNewSheet.Well_Location__c = this.oSelectedLocation.id;
        }
    }

    //m.z.: 23.5.2016  added for check of available previous entries for RM pickval
    private void RetrieveRMCounty(){

        Schema.DescribeFieldResult rmValues = SM_Run_Sheet__c.RM__c.getDescribe();
        List <SelectOption> pickvalsRM = new List<SelectOption>();

        rmSet = new Set<String>();

        String pickVal;
        String pickValToLowerCase;


        for (Schema.Picklistentry picklistEntry : rmValues.getPicklistValues()){
        

            pickvalsRM.add(new SelectOption(pickListEntry.getValue(),pickListEntry.getLabel()));
            pickVal = pickListEntry.getLabel();
            pickValToLowerCase = pickVal.toLowerCase();
            rmSet.add(pickValToLowerCase);

        }
    }


    ///////////////////////////////////////////////////
    // * RETRIEVE WELL ORDER DATA (FAVORITES LIST) * //
    ///////////////////////////////////////////////////

    private void RetrieveWellOrderData()
    {
        List<SM_CustomWellOrder__c> lWellOrder = [SELECT Id, WellIDList__c FROM SM_CustomWellOrder__c WHERE Route__c = :this.sRouteID AND User__c = :this.sCurrentUserId LIMIT :SM_Utilities.SINGLE_RESULT];

        oCustomWellOrderData = (lWellOrder.size() == SM_Utilities.SINGLE_RESULT) ? lWellOrder[0] : null;
        sSavedSelectedWells = (lWellOrder.size() == SM_Utilities.SINGLE_RESULT) ? lWellOrder[0].WellIDList__c : '';
    }

    ///////////////////////////////////////////////
    // * SAVE WELL ORDER DATA (FAVORITES LIST) * //
    ///////////////////////////////////////////////

    private void SaveWellOrderData()
    {
        oCustomWellOrderData = (oCustomWellOrderData == null) ? new SM_CustomWellOrder__c(Route__c = this.sRouteId, User__c = this.sCurrentUserId) : oCustomWellOrderData;

        oCustomWellOrderData.WellIDList__c = sSavedSelectedWells;
        upsert oCustomWellOrderData;
    }

    //////////////////////////////////////////////////////////////////////////
    // * UPDATE WELL ORDER (FAVORITES) AND RE-DIRECT TO ADD SAND RUNSHEET * //
    //////////////////////////////////////////////////////////////////////////

    public PageReference UpdateWellOrder()
    {
        String sMessage = '';

        for(SelectOption oOneOption : this.lSelectedWells)
        {
            sMessage += oOneOption.getValue() + ',';
        }

        this.sSavedSelectedWells = sMessage.left(sMessage.length() - SM_Utilities.SINGLE_RESULT);
        SaveWellOrderData();

        RefreshLocationList();
        return SM_Utilities.SandRedirect('/apex/SM_AddRunSheet?route=' + this.sUrlRouteNum, false);
    }

    ///////////////////////////////////
    // * REFRESH THE SELECTED WELL * //
    ///////////////////////////////////

    public PageReference RefreshSelectedWell()
    {
        List<SM_Run_Sheet_Detail__c> lExistingStings = new List<SM_Run_Sheet_Detail__c>();
        lAddSandDetails = new List<SM_Run_Sheet_Detail__c>();
        SM_Run_Sheet_Detail__c oDetail;
        String sOneTank;
        Integer iTankCount = SM_Utilities.MAX_TANK_NUMBER;

        lH2S_Readings = new List<Well_Location_H2S_Reading__c>();

        this.oSelectedLocation = (sSelectedLocationID == SM_Utilities.NOT_SELECTED) ? null : this.mapLocations.get(sSelectedLocationID);

        if(this.oSelectedLocation == null)
        {
            return null;
        }

        //m.z.: RM picklist
        RetrieveRMCounty();
        RetrieveH2SReadings();
        CheckPreviousSandRunSheet();

        Map<String, Boolean> mapTank = new Map<String, Boolean>();
        List<FM_Run_Sheet__c> lFluidSheets = [SELECT Tank__c, Sour__c FROM FM_Run_Sheet__c WHERE Well__c = :oSelectedLocation.Id AND Date__c = TODAY ORDER BY CreatedDate DESC];

        // NO SHEETS FOUND TODAY, CHECK YESTERDAYS
        if(lFluidSheets.size() == 0)
        {
            lFluidSheets = [SELECT Tank__c, Sour__c FROM FM_Run_Sheet__c WHERE Well__c = :oSelectedLocation.Id AND Date__c = YESTERDAY ORDER BY CreatedDate DESC];
        }

        if(lFluidSheets.size() > iTankCount)
        {
            iTankCount = lFluidSheets.size();
        }

        for(FM_Run_Sheet__c oOneRunSheet : lFluidSheets)
        {
            this.oNewSheet.Saved_H2S__c = oOneRunSheet.Sour__c;
            mapTank.put(oOneRunSheet.Tank__c, true);
        }

        // ALM DEFECT # 172 NO FLUID SHEETS FOUND? SHOULD BE VERY RARE, BUT TO
        // ACCOMMODATE THIS TAKE THE H2S FLAG FROM THE LOCATION

        if(lFluidSheets.size() == 0)
        {
            this.oNewSheet.Saved_H2S__c = (this.oSelectedLocation.Hazardous_H2S__c != null && this.oSelectedLocation.Hazardous_H2S__c.toLowerCase() == 'y') ? true : false;
        }

        for(Integer i = 0; i < iTankCount; i++)
        {
            sOneTank = 'Tank ' + (i + 1);

            lExistingStings = [SELECT Id, Blow_off_location__c, Chem_and_Rate__c, Comments__c, Flood_Up__c, Flowline_push__c, Location_for_Water_Tank__c, Location_for_Water_Well__c, Priority__c, Sand_Level__c, Status__c, Sting_Type__c, Tank__c, Tank_Level__c, Water_Level__c, Tank_Enabled__c FROM SM_Run_Sheet_Detail__c WHERE Tank__c = :sOneTank AND Sand_Run_Sheet__r.Date__c = TODAY AND Sand_Run_Sheet__r.Well_Location__c = :oSelectedLocation.Id LIMIT :SM_Utilities.SINGLE_RESULT];

            if(lExistingStings.size() == 1)
            {
                oDetail = lExistingStings[0];
            }
            else
            {
                oDetail = new SM_Run_Sheet_Detail__c();
                oDetail.Sand_Run_Sheet__c = oNewSheet.Id;
                oDetail.Sand_Level__c = 0;
                oDetail.Water_Level__c = 0;
                oDetail.Sting_Type__c = 'Production Sting';
                oDetail.Priority__c = '2';
                oDetail.Status__c = SM_Utilities.SANDSTING_STATUS_NEW;
                oDetail.Tank__c = sOneTank;
                oDetail.Tank_Level__c = GetRunSheetLevel(oSelectedLocation, sOneTank);

                //Remove default tank selection when editing
                //if(mapTank.get(sOneTank) == true && this.oNewSheet.Id == null)
                //{
                //  oDetail.Tank_Enabled__c = true;
                //}

                oDetail.Location_for_Water_Well__c = this.oSelectedLocation.Id;
                oDetail.Location_for_Water_Tank__c = 'Tank 1';
            }

            lAddSandDetails.add(oDetail);
        }

        return null;
    }

    ///////////////////////////////////////////////////////////
    // * CHECK IF SAND SHEET IS EDITABLE -> ALREADY EXISTS * //
    ///////////////////////////////////////////////////////////

    private Boolean GetViewSandSheetIsEditable(String sRunSheetId)
    {
        List<SM_Run_Sheet__c> lSandSheets = [SELECT Id FROM SM_Run_Sheet__c WHERE Id = :sRunSheetId AND Is_Current_Date__c = true LIMIT :SM_Utilities.SINGLE_RESULT];
        return (sRunSheetId == null || lSandSheets.size() == SM_Utilities.SINGLE_RESULT) ? true : false;
    }

    ////////////////////////////////////////////////////////////
    // * CHECK IF SAND SHEET IS EDITABLE -> CREATE NEW MODE * //
    ////////////////////////////////////////////////////////////

    public Boolean getNewSandSheetIsEditable()
    {
        return (this.oNewSheet.Id == null || this.oNewSheet.Is_Current_Date__c == true) ? true : false;
    }

    private Integer GetRunSheetLevel(Location__c oLocation, String sTank)
    {
        Integer iResult = 0;
        List<FM_Run_Sheet__c> lRunSheets;
        FM_Run_Sheet__c oRunSheet;

        if(oLocation != null && sTank != null)
        {
            lRunSheets = [SELECT Act_Tank_Level__c FROM FM_Run_Sheet__c WHERE Well__r.Id = :oLocation.Id AND Tank__c = :sTank ORDER BY Date__c DESC LIMIT :SM_Utilities.SINGLE_RESULT];

            if(lRunSheets.size() == 1)
            {
                oRunSheet = lRunSheets[0];
                iResult = Integer.valueOf(oRunSheet.Act_Tank_Level__c);
            }
        }

        return iResult;
    }

    public PageReference EditSheet()
    {

        Savepoint oSave = Database.setSavepoint();
        Boolean bValid = true;
        List<SM_Run_Sheet_Detail__c> tankToUpdate = new List<SM_Run_Sheet_Detail__c>();

        
        List<SM_Run_Sheet_Detail__c> tempList = new List<SM_Run_Sheet_Detail__c>(); 
        tempList = lViewSandDetails.deepClone(true,true);    //mz: 31.8.2016 sand request single edit fix

        //for(SM_Run_Sheet_Detail__c oOneDetail : lViewSandDetails)
        for(SM_Run_Sheet_Detail__c oOneDetail : tempList)
        {
            
            if (oOneDetail.Id == sTankId){   

                if(oOneDetail.Status__c == SM_Utilities.SANDSTING_STATUS_CANCELLED && oOneDetail.Comments__c == null)
                {
                    ApexPages.addMessage(new ApexPages.message(ApexPages.severity.ERROR, 'Please enter a reason for cancelling ' + oOneDetail.Tank__c + ' in the comments.'));
                    bValid = false;
                }
                else if(oOneDetail.Status__c == SM_Utilities.SANDSTING_STATUS_ON_HOLD && oOneDetail.Comments__c == null)
                {
                    ApexPages.addMessage(new ApexPages.message(ApexPages.severity.ERROR, 'Please enter a reason for placing ' + oOneDetail.Tank__c + ' On-Hold' + ' in the comments.'));
                    bValid = false;
                }
                else if(oOneDetail.Status__c == SM_Utilities.SANDSTING_STATUS_NO_LOAD && oOneDetail.Comments__c == null)
                {
                    ApexPages.addMessage(new ApexPages.message(ApexPages.severity.ERROR, 'Please enter a reason for No Loads on ' + oOneDetail.Tank__c + ' in the comments.'));
                    bValid = false;
                }

                if(oOneDetail.Sting_Type__c != null)
                {
                    if(((oOneDetail.Sting_Type__c.toLowerCase() == 'sting-to-air') || (oOneDetail.Sting_Type__c.toLowerCase() == 'door pull')) && (oOneDetail.Blow_off_location__c == null))
                    {
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Blow-off location is required for ' + oOneDetail.Tank__c));
                        bValid = false;
                    }
                }

                // Automatic Flowline Push IF Sting-To-Air OR Door Pull
                if((oOneDetail.Sting_Type__c.toLowerCase() == 'sting-to-air') || (oOneDetail.Sting_Type__c.toLowerCase() == 'door pull'))
                {
                    oOneDetail.Flowline_push__c = true;
                }

                

                //mz 10.6.2016
                if (oOneDetail.Primary_Vendor_PM__c == null){

                    oOneDetail.Primary_Vendor__c = null;
                }            

                if (pmDestOrFacId != null && pmDestOrFacId.getSObjectType().getDescribe().getName() == 'Facility__c'){

                    oOneDetail.Primary_Disposal_Facility__c = pmDestOrFacId;
                    oOneDetail.Primary_Disposal_Facility_Ext__c = null;

                }
                else if (pmDestOrFacId != null && pmDestOrFacId.getSObjectType().getDescribe().getName() == 'HOG_Picklist_Manager__c'){
                   
                    oOneDetail.Primary_Disposal_Facility__c = null;
                    oOneDetail.Primary_Disposal_Facility_Ext__c = pmDestOrFacId;
                }
                else if (pmDestOrFacId == null){

                    oOneDetail.Primary_Disposal_Facility__c = null;
                    oOneDetail.Primary_Disposal_Facility_Ext__c = null;
                    oOneDetail.Disposal_Destination__c = null;
                }

                
                tankToUpdate.add(oOneDetail);
        
            }

        }

      
        if(bValid == true)
        {
            try
            {
                system.debug('update oViewSheet');
                update oViewSheet;

                system.debug('update lViewSandDetails');

                System.Debug('tankToUpdate_update :' + tankToUpdate);
                System.Debug('lViewSandDetails_update :' + lViewSandDetails);

                
                if (tankToUpdate.size() > 0)
                {

                    update tankToUpdate[0];

                }    
                //update lViewSandDetails; 

                LoadVendorPicklistValues();
                String sKey;
                //Integer iCount = 0;


                List<SM_Sand_Request_Vendor_Ticket__c> vtToUpsertList = new List<SM_Sand_Request_Vendor_Ticket__c>();

                //for(iCount = 0; iCount < lSandDetailVendors.size(); iCount++)
                //{
                    //sKey = lSandDetailVendors[iCount].Sand_Request__c + '-' + lSandDetailVendors[iCount].Vendor__c + '-' + lSandDetailVendors[iCount].Ticket_Number__c;
                    //lSandDetailVendors[iCount].source_system_id__c = sKey;
                //}

                //mz 13.6.2016
                
                for(SandDetailVendorsWrapper vt :lSandDetailVendorsWrapper){


                    //sKey = vt.vendorTicket.Sand_Request__c + '-' + vt.vendorTicket.Vendor_PM__c  + '-' + vt.vendorTicket.Ticket_Number__c;
                    sKey = (vt.vendorTicket.Vendor_PM__c != null) ?
                            vt.vendorTicket.Sand_Request__c + '-' + pmVendorIdNameMap.get(vt.vendorTicket.Vendor_PM__c) + '-' + vt.vendorTicket.Ticket_Number__c :
                            vt.vendorTicket.Sand_Request__c + '-' + vt.vendorTicket.Vendor__c + '-' + vt.vendorTicket.Ticket_Number__c; 
                    vt.vendorTicket.source_system_id__c = sKey;
                

                    if (vt.vendorTicket.Vendor_PM__c == null){

                        vt.vendorTicket.Vendor__c = null;

                    }

                    if (vt.vendorTicket.Truck_Type_PM__c == null){

                        vt.vendorTicket.Truck_Type__c = null;

                    }

                    if (vt.destinationId != null && vt.destinationId.getSObjectType().getDescribe().getName() == 'Facility__c'){

                        vt.vendorTicket.Disposal_Facility__c = vt.destinationId;
                        vt.vendorTicket.Disposal_Facility_Ext__c = null;
                    }
                    else if (vt.destinationId != null && vt.destinationId.getSObjectType().getDescribe().getName() == 'HOG_Picklist_Manager__c'){

                        vt.vendorTicket.Disposal_Facility__c = null;
                        vt.vendorTicket.Disposal_Facility_Ext__c = vt.destinationId;
                    }

                    else if (vt.destinationId == null) {

                        vt.vendorTicket.Disposal_Facility__c = null;
                        vt.vendorTicket.Disposal_Facility_Ext__c = null;
                        vt.vendorTicket.Disposal_Location_Name__c = null;

                    }
                
                    vtToUpsertList.add(vt.vendorTicket);
                    
                }   

                system.debug('update lSandDetailVendors');
                //upsert lSandDetailVendors;
                upsert vtToUpsertList;

                if (lSandDetailVendorsToRemove.size() > 0)
                {
                    delete lSandDetailVendorsToRemove;
                }

                /*
                if(this.sTankId == null || this.sTankId == '')
                {
                    return RedirectListView();              
                }
                else
                {
                    return RedirectViewSheet();
                }
                */
                return RedirectListView();
            }
            catch(DMLException e)
            {
                ApexPages.addMessages(e);

                //Find Vendors not in database and set Id to null
                //for(SM_Sand_Request_Vendor_Ticket__c vendor :lSandDetailVendors) { mz
                for(SandDetailVendorsWrapper vendor :lSandDetailVendorsWrapper) {
                    if(!lSandDetailVendorsInDb.containsKey(vendor.vendorTicket.Id)) {
                        vendor.vendorTicket.Id = null;
                    }
                }


                Database.rollback(oSave);
            }
        }

        return null;
    }



    public PageReference SaveSheet()
    {
        List<SM_Run_Sheet__c> lFoundSheets = [SELECT Id FROM SM_Run_Sheet__c WHERE Well_Location__c = :oSelectedLocation.Id AND Date__c = :Date.today()];
        List<SM_Run_Sheet__c> lAddSheet = new List<SM_Run_Sheet__c>();
        List<SM_Run_Sheet_Detail__c> lAddDetails;
        List<SM_Run_Sheet_Detail__c> lUpdateDetails;
        Map<String, Boolean> mapTankLocked = new Map<String, Boolean>(); 

        SM_Run_Sheet__c oInsertSheet;
        Savepoint oSave;

        Datetime dTemp;
        String sSheetName;
        Integer iSelectedCount = 0;

        // CAN'T EDIT -> REDIRECT TO LIST VIEW
        if(GetViewSandSheetIsEditable(this.oNewSheet.Id) == false)
        {
            return RedirectListView();
        }

        if(lAddSandDetails != null)
        {
            Boolean bValid = true;
            Boolean bIsVault;

            if(oNewSheet.Sand_Lead__c == null)
            {
                ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Please enter a Sand Lead'));
                bValid = false;
            }

            for(SM_Run_Sheet_Detail__c oOneDetail : lAddSandDetails)
            {
                bIsVault = (oOneDetail.Sting_Type__c == 'Vault') ? true : false;

                if(oOneDetail.Tank_Enabled__c == true)
                {
                    // Increment Selected Count
                    iSelectedCount++;

                    if(oOneDetail.Sting_Type__c == null)
                    {
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Please fill in the Sting Type for ' + oOneDetail.Tank__c));
                        bValid = false;
                    }

                    if(bIsVault == false && oOneDetail.Tank_Level__c == null)
                    {
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Please fill in the Tank Level for ' + oOneDetail.Tank__c));
                        bValid = false;
                    }

                    if(bIsVault == false && oOneDetail.Sand_Level__c == null)
                    {
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Please fill in the Sand Level for ' + oOneDetail.Tank__c));
                        bValid = false;
                    }

                    if(bIsVault == false && oOneDetail.Water_Level__c == null)
                    {
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Please fill in the Water Level for ' + oOneDetail.Tank__c));
                        bValid = false;
                    }

                    if(oOneDetail.Priority__c == null)
                    {
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Please fill in the Priority for ' + oOneDetail.Tank__c));
                        bValid = false;
                    }

                    if(bIsVault == false && oOneDetail.Location_For_Water_Well__c == null)
                    {
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Please fill in the Location for Water (Well) for ' + oOneDetail.Tank__c));
                        bValid = false;
                    }

                    if(bIsVault == false && oOneDetail.Location_For_Water_Tank__c == null)
                    {
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Please fill in the Location for Water (Tank) for ' + oOneDetail.Tank__c));
                        bValid = false;
                    }

                    if(oOneDetail.Sting_Type__c != null)
                    {
                        if(((oOneDetail.Sting_Type__c.toLowerCase() == 'sting-to-air') || (oOneDetail.Sting_Type__c.toLowerCase() == 'door pull')) && (oOneDetail.Blow_off_location__c == null))
                        {
                            ApexPages.addMessage(new ApexPages.message(ApexPages.severity.WARNING, 'Blow-off location is required for ' + oOneDetail.Tank__c));
                            bValid = false;
                        }
                    }
                }
            }

            // Rows Filled In AND Validation Passed
            if(iSelectedCount > 0 && bValid == true)
            {
                dTemp = Datetime.newInstance(oNewSheet.Date__c.year(), oNewSheet.Date__c.month(), oNewSheet.Date__c.day());
                sSheetName = oSelectedLocation.Name + ' - ' + dTemp.format('yyyy-MM-dd');

                oInsertSheet = new SM_Run_Sheet__c();

                oInsertSheet.Name = sSheetName;
                oInsertSheet.OIL_Prod_m3__c = oNewSheet.OIL_Prod_m3__c;
                oInsertSheet.RM__c = oNewSheet.RM__c;
                oInsertSheet.Sand_Lead__c = oNewSheet.Sand_Lead__c;
                oInsertSheet.Saved_H2s__c = oNewSheet.Saved_H2s__c;             
                oInsertSheet.Water_Prod_m3__c = oNewSheet.Water_Prod_m3__c;
                oInsertSheet.Water_Transfer__c = oNewSheet.Water_Transfer__c;
                //This field was not used and can be removed mbrimus@ 9.3.2017
                //oInsertSheet.Well_Event__c = oNewSheet.Well_Event__c;
                oInsertSheet.Well_Location__c = oSelectedLocation.Id;

                if(lFoundSheets.size() > 0)
                {
                    SM_Run_Sheet__c oFoundSheet = lFoundSheets[0];
                    oInsertSheet.Id = oFoundSheet.Id;

                    List<SM_Run_Sheet_Detail__c> lCurrentDetail = [SELECT Id, Tank__c, Status__c FROM SM_Run_Sheet_Detail__c WHERE Sand_Run_Sheet__c = :oInsertSheet.Id];

                    for(SM_Run_Sheet_Detail__c oOneFoundDetail : lCurrentDetail)
                    {
                        if(oOneFoundDetail.Status__c != SM_Utilities.SANDSTING_STATUS_NEW)
                        {
                            mapTankLocked.put(oOneFoundDetail.Tank__c, true);
                        }
                    }
                }

                lAddDetails = new List<SM_Run_Sheet_Detail__c>();
                lUpdateDetails = new List<SM_Run_Sheet_Detail__c>();

                for(SM_Run_Sheet_Detail__c oOneDetail : lAddSandDetails)
                {
                    if(oOneDetail.Tank_Enabled__c == true && mapTankLocked.get(oOneDetail.Tank__c) != true)
                    {
                        SM_Run_Sheet_Detail__c oNewDetail = new SM_Run_Sheet_Detail__c();

                        oNewDetail.Blow_off_location__c = oOneDetail.Blow_off_location__c;
                        oNewDetail.Chem_and_rate__c = oOneDetail.Chem_and_rate__c;
                        oNewDetail.Comments__c = oOneDetail.Comments__c;
                        oNewDetail.Flood_Up__c = oOneDetail.Flood_Up__c;

                        // Automatic Flowline Push IF Sting-To-Air OR Door Pull
                        if((oOneDetail.Sting_Type__c.toLowerCase() == 'sting-to-air') || (oOneDetail.Sting_Type__c.toLowerCase() == 'door pull'))
                        {
                            oNewDetail.Flowline_push__c = true;
                        }
                        else
                        {
                            oNewDetail.Flowline_push__c = oOneDetail.Flowline_push__c;
                        }

                        oNewDetail.Location_for_Water_Tank__c = oOneDetail.Location_for_Water_Tank__c;
                        oNewDetail.Location_for_Water_Well__c = oOneDetail.Location_for_Water_Well__c;
                        oNewDetail.Priority__c = oOneDetail.Priority__c;
                        oNewDetail.Sand_Level__c = oOneDetail.Sand_Level__c;
                        oNewDetail.Sting_Type__c = oOneDetail.Sting_Type__c;
                        oNewDetail.Tank__c = oOneDetail.Tank__c;
                        oNewDetail.Tank_Enabled__c = oOneDetail.Tank_Enabled__c;
                        oNewDetail.Tank_Level__c = oOneDetail.Tank_Level__c;
                        oNewDetail.Water_Level__c = oOneDetail.Water_Level__c;

                        if(oOneDetail.Id != null)
                        {
                            oNewDetail.Id = oOneDetail.Id;
                            lUpdateDetails.add(oNewDetail);
                        }
                        else
                        {
                            oNewDetail.Name = oInsertSheet.Name + ' / ' + oNewDetail.Tank__c;
                            lAddDetails.add(oNewDetail);
                        }
                    }
                }

                if(lAddDetails.size() > 0 || lUpdateDetails.size() > 0)
                {
                    oSave = Database.setSavepoint();

                    try
                    {
                        if(oInsertSheet.Id != null)
                        {
                            update oInsertSheet;
                        }
                        else
                        {
                            insert oInsertSheet;
                        }

                        for(SM_Run_Sheet_Detail__c oOneDetail : lAddDetails)
                        {
                            oOneDetail.Sand_Run_Sheet__c = oInsertSheet.Id;
                        }

                        if(lAddDetails.size() > 0)
                        {
                            insert lAddDetails;
                        }

                        if(lUpdateDetails.size() > 0)
                        {
                            update lUpdateDetails;
                        }

                        //H2S Settings
                        /*
                        if(NewH2SReading.Value__c <> null)
                        {
                            insert NewH2SReading;
                        }
                        */
                    }
                    catch(DMLException e)
                    {
                        Database.rollback(oSave);
                        ApexPages.addMessage(new ApexPages.message(ApexPages.severity.ERROR, 'Error creating Sand Run Sheet'));

                        return null;
                    }

                    return RedirectListView();
                }
                else
                {
                    return null;
                }
            }
            else
            {
                return null;
            }
        }
        else
        {
            return null;
        }
    }


    //17.6.2016 mz: wrapper to bind disposal id param from vf page with vendor ticket record 
    public class SandDetailVendorsWrapper
    {

        public SM_Sand_Request_Vendor_Ticket__c vendorTicket  {get; private set;}
        public Id destinationId {get; set;}

        public SandDetailVendorsWrapper (SM_Sand_Request_Vendor_Ticket__c vTicket, Id destId){

            this.vendorTicket = vTicket;
            this.destinationId = destId;

        }

    }


    public Boolean getCanSubmitForm()
    {
        Boolean bCanSubmit = false;

        if(lAddSandDetails != null)
        {
            for(SM_Run_Sheet_Detail__c oOneDetail : lAddSandDetails)
            {
                if(oOneDetail.Tank_Enabled__c == true)
                {
                    bCanSubmit = true;
                }
            }
        }

        return bCanSubmit;
    }

    //////////////////////////////////////////
    // * REDIRECT TO CUSTOMIZE WELL ORDER * //
    //////////////////////////////////////////

    public PageReference RedirectCustomizeWellOrder()
    {
        return SM_Utilities.SandRedirect('/apex/SM_CustomizeWellOrder?route=' + this.sRouteNum, false);
    }

    ///////////////////////////////////////////
    // * REDIRECT TO ADD NEW SAND RUNSHEET * //
    ///////////////////////////////////////////

    public PageReference RedirectExitWellOrderForm()
    {
        return SM_Utilities.SandRedirect('/apex/SM_AddRunSheet?route=' + this.sUrlRouteNum, true);
    }

    ////////////////////////////////////////
    // * REDIRECT TO EDIT SAND RUNSHEET * //
    ////////////////////////////////////////

    public PageReference RedirectEditSheet()
    {
        return SM_Utilities.SandRedirect('/apex/SM_EditRunSheet?id=' + this.oViewSheet.Id, true);
    }

    //////////////////////////////////////////////
    // * REDIRECT TO SAND RUNSHEET VIEW MODE * ///
    //////////////////////////////////////////////

    public PageReference RedirectViewSheet()
    {
        return SM_Utilities.SandRedirect('/apex/SM_ViewRunSheet?id=' + this.oViewSheet.Id, true);
    }

    ///////////////////////////////////////////////////
    // * REDIRECT TO NEW SAND RUNSHEET -> OPERATOR * //
    ///////////////////////////////////////////////////

    public PageReference RedirectOperatorSheet()
    {
        return SM_Utilities.SandRedirect('/apex/SM_AddRunSheet?wellid=' + this.oViewSheet.Well_Location__c, true);
    }

    //////////////////////////////////////////////
    // * REDIRECT TO SAND RUNSHEET LIST VIEW * ///
    //////////////////////////////////////////////

    public PageReference RedirectListView()
    {
        Schema.DescribeSObjectResult oSchemaResult = SM_Run_Sheet_Detail__c.sObjectType.getDescribe();
        return SM_Utilities.SandRedirect('/' + oSchemaResult.getKeyPrefix(), true);
    }

    /////////////////////////////////
    // * GETTER + SETTER METHODS * //
    /////////////////////////////////

    public List<SM_Run_Sheet_Detail__c> getAddSandDetails()
    {
        return this.lAddSandDetails;
    }

    public void setAddSandDetails(List<SM_Run_Sheet_Detail__c> lNewDetails)
    {
        this.lAddSandDetails = lNewDetails;
    }

    public List<SelectOption> getFullRouteList()
    {
        return this.lRouteList;
    }

    public List<SelectOption> getFullLocationList()
    {
        return this.lLocationList;
    }

    public SM_Run_Sheet__c getNewSheet()
    {
        return this.oNewSheet;
    }

    public void setNewSheet(SM_Run_Sheet__c oSavedSheet)
    {
        this.oNewSheet = oSavedSheet;
    }

    public SM_Run_Sheet__c getViewSheet()
    {
        return this.oViewSheet;
    }

    public List<SM_Run_Sheet_Detail__c> getViewSheetDetail()
    {
        return this.lViewSandDetails;
    }


    public List<SandDetailVendorsWrapper> getViewVendorDetailWrapper()
    {
        return this.lSandDetailVendorsWrapper;
    }

    
    public List<SM_Sand_Request_Vendor_Ticket__c> getViewVendorDetail()
    {
        return this.lSandDetailVendors;
    }


    public List<SM_Run_Sheet_Detail__c> getStaticSRList()
    {
        return this.viewSRList;
    }
    

    public PageReference removeVendorLine()
    {
        // is this vendor line already stored (with an ID)?  If so, add that to the list of vendor lines to remove.
        // If not, then there's nothing needs t obe done.
        if (lSandDetailVendorsWrapper[rowToRemove].vendorTicket.Id != null)
        {
            lSandDetailVendorsToRemove.add(lSandDetailVendorsWrapper[rowToRemove].vendorTicket);
        }
        lSandDetailVendorsWrapper.remove(rowToRemove);
        Integer currentVendorCount = sandDetailVendorCountMap.get(sandRequestId);
        sandDetailVendorCountMap.put(sandRequestId, --currentVendorCount);
        return null;
    }
    
    public PageReference addVendorLine()
    {
        SM_Sand_Request_Vendor_Ticket__c newVendorTicket = new SM_Sand_Request_Vendor_Ticket__c();
        newVendorTicket.Sand_Request__c = sandRequestId;  
        Id newDestId = null;
       SandDetailVendorsWrapper oneWrapper;

        oneWrapper = new SandDetailVendorsWrapper(newVendorTicket, newDestId);
        lSandDetailVendorsWrapper.add(oneWrapper);


        //lSandDetailVendors.add(newVendorTicket);
        Integer currentVendorCount = sandDetailVendorCountMap.get(sandRequestId);
        sandDetailVendorCountMap.put(sandRequestId, ++currentVendorCount);
        return null;
    }
    
    public String getCurrentSour()
    {
        return (this.oNewSheet.Saved_H2S__c == true) ? 'Y' : 'N';
    }

    public Boolean getIsHogAdmin() 
    {
        return this.bIsHogAdmin;
    }

    public Boolean getIsSandLead()
    {
        return this.bIsSandLead;
    }

    public String getRouteNumber()
    {
        return this.sRouteNum;
    }

    public String getWellId()
    {
        return this.sWellId;
    }

    public String getRouteId()
    {
        return this.sRouteId;
    }

    public void setRouteId(String sNewRoute)
    {
        this.sRouteId = sNewRoute;
    }
    
    @RemoteAction
    public static List<String> searchBlowOffLocation(String searchString) {
  
        List<SM_Run_Sheet_Detail__c> result = Database.query('select Id, Blow_off_location__c from SM_Run_Sheet_Detail__c where Blow_off_location__c like \'%' + String.escapeSingleQuotes(searchString) + '%\' and ( CreatedById = \''+UserInfo.getUserId()+'\' or LastModifiedById = \''+UserInfo.getUserId()+'\' ) order by Blow_off_location__c desc Limit 20');                                   
        
        Set<string> resultSet = new Set<String>();
        for(SM_Run_Sheet_Detail__c rsd : result){
            resultSet.add(rsd.Blow_off_location__c);
        }
        
        return new List<String>(resultSet);
    }   
}